PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = lrwi-newsin
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: lrwi-newsin.pgoblin.m4,v 1.4 2022/10/09 04:40:23 babolo Exp $

#echo    Q
##Q copy E
##q copy
#style   00Q00Q
Q
#style   00Q00q
q
#job
local -zz
#connect 000_
CIPADBMS CIPALITEVAR/CIPALITEDB
#connect 0002
sqlite3 CIPALITEVAR/BASE.sqlite
#perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
PRAGMA temp_store = 2;
#perform 0002
PRAGMA application_id = 0x43495041;
#perform 0002  #######################################################      ####
CREATE TEMP TABLE u(u real) STRICT;
#perform 0002
INSERT INTO u VALUES(VERS);
#perform 0002
CREATE TEMP TABLE v(v real) STRICT;
#cat     _
PREFIX/include/babolo/PKG.VERSION
#trap
#echo
@@@Ignore it

#perform 0002
INSERT INTO v VALUES(VERS);
#perform 0002
UPDATE u SET u = NULL
#return
#copyin  00_2
COPY v;
#untrap
#wait
#close   _0_
#select  0002
SELECT 'PKG'
     , ':' || NULLIF(PROTOVER, '')
     , ' File=' || CAST(CASE WHEN u.u IS NOT NULL THEN v.v END AS TEXT)
     , ' DB=' || CAST(SQNM(version).SQAT(major) AS TEXT) || '.' || SQNM(version).SQAT(minor)
     , '
'FROM u CROSS JOIN v CROSS JOIN SQNM(version)
 WHERE SQNM(version).SQAT(pkg) == 'PKG'
   AND COALESCE(SQNM(version).SQAT(protover) == NULLIF(PROTOVER, ''), 1)
;
#perform 0002  #########################################################################    ####
CREATE TEMP TABLE SQNM(tmpnews)                     -- 
     ( SQAT(news)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(date)  text                               -- 
     , SQAT(short) text                               -- 
     , SQAT(full)  text                               --  
     ) STRICT
;
#perform 0002  #############################################################     ####
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 1
      , '2016-03-14'
      , '  lrwi.ru '
      , '#echo    n
                '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 2
      , '2016-03-21'
      , '  lrwi.ru'
      , '#echo    n
           '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 3
      , '2016-03-22'
      , '  lrwi.ru '
      , '#echo    n
          lrwi.ru    '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 4
      , '2016-03-23'
      , ' WWW '
      , '#echo    n
           www.lrwi.ru  HTTP ,  .'
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 5
      , '2016-03-25'
      , '  '
      , NULL
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 6
      , '2016-03-28'
      , '  '
      , NULL
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 7
      , '2016-04-07'
      , '  ""'
      , '#echo    n
              '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 8
      , '2016-05-01'
      , '   '
      , NULL
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 9
      , '2016-05-02'
      , '    '
      , '#echo    n
      '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 10
      , '2016-05-09'
      , '      '
      , NULL
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 11
      , '2016-05-23'
      , ' '
      , '#echo    n
          1     '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 12
      , '2017-01-06'
      , ' '
      , '#echo    n
                ,
              ,    '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 13
      , '2017-01-15'
      , ' '
      , '#echo    n
            '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 14
      , '2018-03-04'
      , ''
      , '#echo    n
              '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 16
      , '2019-01-07'
      , '   '
      , '#echo    n
                    '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 17
      , '2019-01-08'
      , ' '
      , '#echo    n
              '
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 18
      , '2019-02-10'
      , ' '
      , '#echo    n
         ,      ( )'
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 19
      , '2019-04-14'
      , '   '
      , '#echo    n
          ,  .
                -- , , .
           --         .
           ,       ,
               " . "
               ţ   --
         ", , , , , ",
             ,      .'
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 22
      , '2020-10-07'
      , '<b>
                .
         </b>
         <p class="t">
          <img src="n/edpuzzle.png" alt="">
         </p>'
      , '
##select  _00_
SELECT CINM(x).CIAT(sess) AS sess, CINM(pnode).CIAT(p) AS page
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(m) == ''BASE'' AND CINM(pnode).CIAT(v) == ''oled''
;
##select  n0_2
SELECT ''<p>
          <a href="https://edpuzzle.com/media/5ef5f13c8de9173f3f001823">
            ""
          </a>
          (    - )
         </p>
         <p>
               Edpuzzle. ,     -   !
               ,     :
          <a href="https://www.powtoon.com/s/eFngL7Ebwha/1/m">
           powtoon
          </a>
          ,
          <a href="https://quizizz.com/join/quiz/5efe3b34bf08bf001b766828/start">
           quizizz
          </a>
          ,
          <a href="https://quizlet.com/ru/514490680/%D0%9D%D0%BE%D0%B2%D1%8B%D0%B5-%D1%81%D0%BB%D0%BE%D0%B2%D0%B0-%D0%BF%D0%BE-%D1%82%D0%B5%D0%BC%D0%B5-%D0%9E%D0%B4%D0%B5%D0%B6%D0%B4%D0%B0-flash-cards/">
           quizlet
          </a>
          .
                 ,     ,
             
          <a href="https://www.src-master.ru/seminar/author.php?ID=33362">
             !
          </a>
            ,     
                !
         </p>
         <div class="r">
          <a href="?'', ?1, ''='', ?2, ''&m=1">
             
          </a>
         </div>''
##close   _0_
;'
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 24
      , '2021-11-20'
      , '<b>
             .. , ..  " "
         </b>
         <p class="t">
          <img src="n/exto.png" alt="">
         </p>'
      , '#echo    n
         <p>
          <a href="https://www.flinta.ru/book.php?id=2181">
             ""      
           " " (B2-C1).
          </a>
         </p>
         <p>
             - 
              " "
           ,     ԣ
                  .
         </p>
         <p>
               ,
              " "  .
         </p>
         <p>
                     :
          <ul>
           <li>
              ,    
              ,
           </li>
           <li>
              ,
                  
            . ..   ,
           </li>
           <li>
                ,
                 .
           </li>
          </ul>
         </p>
         <p>
           ,
          <br>
                
         </p>
         <p>
          <i>     . </i>
         </p>'
;
#perform 0002
INSERT INTO SQNM(tmpnews)(SQAT(news), SQAT(date), SQAT(short), SQAT(full))
 SELECT 25
      , '2022-07-05'
      , ' ,     '
      , '#echo    n
              .
         <a href="https://linguanet.ru/fakultety-i-instituty/fakultet-po-obucheniyu-inostrannykh-grazhdan/dopolnitelnye-obrazovatelnye-programmy/teoriya-i-praktika-prepodavaniya-russkogo-yazyka-kak-inostrannogo/o-programme.php">
             
         </a>
    .'
;
#begin   0002  ##########################################################     ####
#select  _002
DELETE FROM SQNM(news)
 WHERE SQAT(news) NOT IN (SELECT SQNM(tmpnews).SQAT(news) FROM SQNM(tmpnews))
 RETURNING '-news', SQNM(news).SQAT(news), SQNM(news).SQAT(date), SQNM(news).SQAT(short)
;
#display 00_00q
#select  _002
UPDATE SQNM(news)
   SET SQAT(date)  = SQNM(tmpnews).SQAT(date)
     , SQAT(short) = SQNM(tmpnews).SQAT(short)
     , SQAT(full)  = SQNM(tmpnews).SQAT(full)
 FROM SQNM(tmpnews)
 WHERE SQNM(tmpnews).SQAT(news) == SQNM(news).SQAT(news)
   AND (  SQNM(tmpnews).SQAT(date)  IS NOT SQNM(news).SQAT(date)
       OR SQNM(tmpnews).SQAT(short) IS NOT SQNM(news).SQAT(short)
       OR SQNM(tmpnews).SQAT(full)  IS NOT SQNM(news).SQAT(full)
       )
 RETURNING '~news', SQNM(news).SQAT(news), SQNM(news).SQAT(date), SQNM(news).SQAT(short)
;
#display 00_00q
#perform 0002
INSERT INTO SQNM(news)
 SELECT SQNM(tmpnews).SQAT(news)
      , SQNM(tmpnews).SQAT(date)
      , SQNM(tmpnews).SQAT(short)
      , SQNM(tmpnews).SQAT(full)
  FROM SQNM(tmpnews) LEFT JOIN SQNM(news) USING(SQAT(news))
  WHERE SQNM(news).SQAT(news) IS NULL
 RETURNING '+news', SQNM(news).SQAT(news), SQNM(news).SQAT(date), SQNM(news).SQAT(short)
;
#end     0002
#perform 0002
INSERT OR REPLACE INTO SQNM(version)(SQAT(pkg), SQAT(protover), SQAT(major), SQAT(minor))
 VALUES('PKG', NULL, MAJOR, 'MINOR')
;
#
